JeiWebAppGestao/Controllers/AdminsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using JeiWebAppGestao.Data;
using JeiWebAppGestao.Models;
using JeiWebAppGestao.Filters;
using System.Security.Cryptography;
using System.Text;

namespace JeiWebAppGestao.Controllers
{
    [RoleFilter(Perfil = "SuperAdmin")]
    public class AdminsController : Controller
    {
        private readonly JeiWebAppGestaoContext _context;

        public AdminsController(JeiWebAppGestaoContext context)
        {
            _context = context;
        }

        // GET: Admins
        public async Task<IActionResult> Index()
        {
            return View(await _context.Admin.ToListAsync());
        }

        // GET: Admins/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var admin = await _context.Admin
                .FirstOrDefaultAsync(m => m.Id == id);
            if (admin == null)
            {
                return NotFound();
            }

            return View(admin);
        }

        // GET: Admins/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: Admins/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Id,Username,Password")] Admin admin)
        {

            SHA512 sha512 = SHA512Managed.Create();
            byte[] bytes = sha512.ComputeHash(Encoding.UTF8.GetBytes(admin.Password), 0, Encoding.UTF8.GetByteCount(admin.Password));
            string passHash = Convert.ToBase64String(bytes);

            admin.Password = passHash;
            if (ModelState.IsValid)
            {
                _context.Add(admin);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(admin);
        }

        // GET: Admins/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var admin = await _context.Admin.FindAsync(id);
            if (admin == null)
            {
                return NotFound();
            }
            return View(admin);
        }

        // POST: Admins/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Id,Username,Password")] Admin admin)
        {
            if (id != admin.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(admin);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!AdminExists(admin.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(admin);
        }

        // GET: Admins/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var admin = await _context.Admin
                .FirstOrDefaultAsync(m => m.Id == id);
            if (admin == null)
            {
                return NotFound();
            }

            return View(admin);
        }

        // POST: Admins/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var admin = await _context.Admin.FindAsync(id);
            _context.Admin.Remove(admin);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool AdminExists(int id)
        {
            return _context.Admin.Any(e => e.Id == id);
        }
    }
}

JeiWebAppGestao/Controllers/PremiosController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using JeiWebAppGestao.Data;
using JeiWebAppGestao.Models;
using Microsoft.AspNetCore.Http;

namespace JeiWebAppGestao.Controllers
{
    public class PremiosController : Controller
    {
        private readonly JeiWebAppGestaoContext _context;

        public PremiosController(JeiWebAppGestaoContext context)
        {
            _context = context;
        }

        // GET: Premios
        public async Task<IActionResult> Index()
        {
            return View(await _context.Premios.Include(x => x.Admin).OrderBy(x => x.Id).ToListAsync());
        }

        // GET: Premios/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var premios = await _context.Premios
                .FirstOrDefaultAsync(m => m.Id == id);
            if (premios == null)
            {
                return NotFound();
            }

            return View(premios);
        }

        // GET: Premios/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: Premios/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Id,Nome,NumAluno,Date")] Premios premios)
        {
            string Username = HttpContext.Session.GetString("Username");
            Admin admin = _context.Admin.FirstOrDefault(x => x.Username == Username);

            premios.Date = DateTime.Now;
            premios.Admin = admin;

            if (ModelState.IsValid)
            {
                _context.Add(premios);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(premios);
        }

        // GET: Premios/Edit/5
        //public async Task<IActionResult> Edit(int? id)
        //{
        //    if (id == null)
        //    {
        //        return NotFound();
        //    }

        //    var premios = await _context.Premios.FindAsync(id);
        //    if (premios == null)
        //    {
        //        return NotFound();
        //    }
        //    return View(premios);
        //}

        //// POST: Premios/Edit/5
        //// To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        //// more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public async Task<IActionResult> Edit(int id, [Bind("Id,Nome,NumAluno,Date")] Premios premios)
        //{
        //    if (id != premios.Id)
        //    {
        //        return NotFound();
        //    }

        //    if (ModelState.IsValid)
        //    {
        //        try
        //        {
        //            _context.Update(premios);
        //            await _context.SaveChangesAsync();
        //        }
        //        catch (DbUpdateConcurrencyException)
        //        {
        //            if (!PremiosExists(premios.Id))
        //            {
        //                return NotFound();
        //            }
        //            else
        //            {
        //                throw;
        //            }
        //        }
        //        return RedirectToAction(nameof(Index));
        //    }
        //    return View(premios);
        //}

        //// GET: Premios/Delete/5
        //public async Task<IActionResult> Delete(int? id)
        //{
        //    if (id == null)
        //    {
        //        return NotFound();
        //    }

        //    var premios = await _context.Premios
        //        .FirstOrDefaultAsync(m => m.Id == id);
        //    if (premios == null)
        //    {
        //        return NotFound();
        //    }

        //    return View(premios);
        //}

        //// POST: Premios/Delete/5
        //[HttpPost, ActionName("Delete")]
        //[ValidateAntiForgeryToken]
        //public async Task<IActionResult> DeleteConfirmed(int id)
        //{
        //    var premios = await _context.Premios.FindAsync(id);
        //    _context.Premios.Remove(premios);
        //    await _context.SaveChangesAsync();
        //    return RedirectToAction(nameof(Index));
        //}

        private bool PremiosExists(int id)
        {
            return _context.Premios.Any(e => e.Id == id);
        }
    }
}

JeiWebAppGestao/Controllers/RifaPs4Controller.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using JeiWebAppGestao.Data;
using JeiWebAppGestao.Models;
using JeiWebAppGestao.Filters;
using Microsoft.AspNetCore.Http;

namespace JeiWebAppGestao.Controllers
{
    [RoleFilter(Perfil = "Admin")]
    public class RifaPs4Controller : Controller
    {
        private readonly JeiWebAppGestaoContext _context;

        public RifaPs4Controller(JeiWebAppGestaoContext context)
        {
            _context = context;
        }

        // GET: RifaPs4
        public async Task<IActionResult> Index()
        {
            return View(await _context.RifaPs4.Include(x => x.Admin).OrderBy(x => x.Id).ToListAsync());
        }

        // GET: RifaPs4/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var rifaPs4 = await _context.RifaPs4
                .FirstOrDefaultAsync(m => m.Id == id);
            if (rifaPs4 == null)
            {
                return NotFound();
            }

            return View(rifaPs4);
        }

        // GET: RifaPs4/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: RifaPs4/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(int num,[Bind("Id,numAluno,Nome,Email,Data")] RifaPs4 rifaPs4)
        {
             string Username =  HttpContext.Session.GetString("Username");
            Admin admin = _context.Admin.FirstOrDefault(x => x.Username == Username);

            rifaPs4.Data = DateTime.Now;
            rifaPs4.Admin = admin;

            if (ModelState.IsValid)
            {
                for(int i = 0; i <= num; i++)
                _context.Add(rifaPs4);
                await _context.SaveChangesAsync();
                return RedirectToAction("Index","Home");
            }
            return View(rifaPs4);
        }

        // GET: RifaPs4/Edit/5
        //public async Task<IActionResult> Edit(int? id)
        //{
        //    if (id == null)
        //    {
        //        return NotFound();
        //    }

        //    var rifaPs4 = await _context.RifaPs4.FindAsync(id);
        //    if (rifaPs4 == null)
        //    {
        //        return NotFound();
        //    }
        //    return View(rifaPs4);
        //}

        //// POST: RifaPs4/Edit/5
        //// To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        //// more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public async Task<IActionResult> Edit(int id, [Bind("Id,numAluno,Nome,Email,Data")] RifaPs4 rifaPs4)
        //{
        //    if (id != rifaPs4.Id)
        //    {
        //        return NotFound();
        //    }

        //    if (ModelState.IsValid)
        //    {
        //        try
        //        {
        //            _context.Update(rifaPs4);
        //            await _context.SaveChangesAsync();
        //        }
        //        catch (DbUpdateConcurrencyException)
        //        {
        //            if (!RifaPs4Exists(rifaPs4.Id))
        //            {
        //                return NotFound();
        //            }
        //            else
        //            {
        //                throw;
        //            }
        //        }
        //        return RedirectToAction(nameof(Index));
        //    }
        //    return View(rifaPs4);
        //}

        //// GET: RifaPs4/Delete/5
        //public async Task<IActionResult> Delete(int? id)
        //{
        //    if (id == null)
        //    {
        //        return NotFound();
        //    }

        //    var rifaPs4 = await _context.RifaPs4
        //        .FirstOrDefaultAsync(m => m.Id == id);
        //    if (rifaPs4 == null)
        //    {
        //        return NotFound();
        //    }

        //    return View(rifaPs4);
        //}

        //// POST: RifaPs4/Delete/5
        //[HttpPost, ActionName("Delete")]
        //[ValidateAntiForgeryToken]
        //public async Task<IActionResult> DeleteConfirmed(int id)
        //{
        //    var rifaPs4 = await _context.RifaPs4.FindAsync(id);
        //    _context.RifaPs4.Remove(rifaPs4);
        //    await _context.SaveChangesAsync();
        //    return RedirectToAction(nameof(Index));
        //}

        private bool RifaPs4Exists(int id)
        {
            return _context.RifaPs4.Any(e => e.Id == id);
        }
    }
}

JeiWebAppGestao/Views/Shared/Erro.cshtml
@{
    ViewData["Title"] = "Erro";
}

<h1>Erro de acesso</h1>

@ViewData["mensagem"]

JeiWebAppGestao/Views/Shared/_Layout.cshtml
@using Microsoft.AspNetCore.Http;
@using JeiWebAppGestao.Controllers
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - JeiWebAppGestao</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                @if (HomeController.estaAutenticado(Context))
                {
                   
                    <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">JeiWebAppGestao</a>
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                            aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                        <ul class="navbar-nav flex-grow-1">
                            @if (Context.Session.GetString("Perfil") == "SuperAdmin")
                            {
                              <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Admins" asp-action="Index">Gerir Administradores</a>
                                </li>
                            }
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Premios" asp-action="Index">Premios</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="RifaPs4" asp-action="Index">Rifas PS4</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="RifaTeles" asp-action="Index">Rifas Telemóvel</a>
                            </li>
                        </ul>
                    </div>
                   
                    <div class="col-lg-4 col-sm-4 menu-top-right">
                        <a asp-controller="Home" asp-action="Logout">
                            <span>
                                Logout
                            </span>
                        </a>
                    </div>

                }
                else
                {
                    <div class="col-lg-4 col-sm-4 menu-top-right">
                        <a asp-controller="Home" asp-action="Login">
                            <span>
                                Login
                            </span>
                        </a>
                    </div>
                }
            

            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - JeiWebAppGestao - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>